c     see readme.txt for general info about adding functions

c     For each equation of the book, put a corresponding function here
c     that has the result of the equation as first argument, followed
c     by its parameters.  The function should return integer 0 if all
c     is well, and a nonzero integer if something went wrong.  If
c     something goes wrong, the first argument should be left unchanged.

      integer function err19p(p,rgas,r,t)
      implicit none
      real r,rgas,t,p
      if(rgas.le.0.)then
         call out(0,'*** R must be greater than zero')
         goto 9900
      endif
      p=r*rgas*t
 9000 err19p=0
      return
 9900 err19p=1
      return
      end

      integer function err19t(t,rgas,p,r)
      implicit none
      real r,rgas,t,p
      if(rgas.le.0.)then
         call out(0,'*** R must be greater than zero')
         goto 9900
      endif
      if(r.le.0.)then
         call out(0,'*** rho must be greater than zero')
         goto 9900
      endif
      t=p/rgas/r
 9000 err19t=0
      return
 9900 err19t=1
      return
      end

      integer function err19r(r,rgas,t,p)
      implicit none
      real r,rgas,t,p
      if(rgas.le.0.)then
         call out(0,'*** R must be greater than zero')
         goto 9900
      endif
      if(t.le.0.)then
         call out(0,'*** T must be greater than zero')
         goto 9900
      endif
      r=p/rgas/t
 9000 err19r=0
      return
 9900 err19r=1
      return
      end

      integer function err122(cp,gam,rgas)
      implicit none
      real cp,gam,rgas
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(rgas.le.0.)then
         call out(0,'*** R must be greater than zero')
         goto 9900
      endif
      cp=rgas*gam/(gam-1.)
 9000 err122=0
      return
 9900 err122=1
      return
      end

      integer function err123(cv,gam,rgas)
      implicit none
      real cv,gam,rgas
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(rgas.le.0.)then
         call out(0,'*** R must be greater than zero')
         goto 9900
      endif
      cv=rgas/(gam-1.)
 9000 err123=0
      return
 9900 err123=1
      return
      end

      integer function err136(ds_cv,gam,t2_t1,p2_p1)
      implicit none
      real ds_cv,gam,t2_t1,p2_p1
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(t2_t1.le.0.)then
         call out(0,'*** T2/T1 must be greater than zero')
         goto 9900
      endif
      if(p2_p1.le.0.)then
         call out(0,'*** p2/p1 must be greater than zero')
         goto 9900
      endif
      ds_cv=gam*alog(t2_t1)-(gam-1.)*alog(p2_p1)
 9000 err136=0
      return
 9900 err136=1
      return
      end

      integer function err137(ds_cv,gam,p2_p1,r2_r1)
      implicit none
      real ds_cv,gam,p2_p1,r2_r1
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(p2_p1.le.0.)then
         call out(0,'*** p2/p1 must be greater than zero')
         goto 9900
      endif
      if(r2_r1.le.0.)then
         call out(0,'*** rho2/rho1 must be greater than zero')
         goto 9900
      endif
      ds_cv=alog(p2_p1)-gam*alog(r2_r1)
 9000 err137=0
      return
 9900 err137=1
      return
      end

      integer function ept143(p2_p1,gam,t2_t1)
      implicit none
      real p2_p1,gam,t2_t1
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(t2_t1.le.0.)then
         call out(0,'*** T2/T1 must be greater than zero')
         goto 9900
      endif
      p2_p1=t2_t1**(gam/(gam-1.))
 9000 ept143=0
      return
 9900 ept143=1
      return
      end

      integer function etp143(t2_t1,gam,p2_p1)
      implicit none
      real t2_t1,gam,p2_p1
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(p2_p1.le.0.)then
         call out(0,'*** p2/p1 must be greater than zero')
         goto 9900
      endif
      t2_t1=p2_p1**((gam-1.)/gam)
 9000 etp143=0
      return
 9900 etp143=1
      return
      end

      integer function epr143(p2_p1,gam,r2_r1)
      implicit none
      real p2_p1,gam,r2_r1
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(r2_r1.le.0.)then
         call out(0,'*** rho2/rho1 must be greater than zero')
         goto 9900
      endif
      p2_p1=r2_r1**gam
 9000 epr143=0
      return
 9900 epr143=1
      return
      end

      integer function erp143(r2_r1,gam,p2_p1)
      implicit none
      real r2_r1,gam,p2_p1
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(p2_p1.le.0.)then
         call out(0,'*** p2/p1 must be greater than zero')
         goto 9900
      endif
      r2_r1=p2_p1**(1./gam)
 9000 erp143=0
      return
 9900 erp143=1
      return
      end

      integer function err319(a,gam,p,r)
      implicit none
      real a,gam,p,r
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(p.le.0.)then
         call out(0,'*** p must be greater than zero')
         goto 9900
      endif
      if(r.le.0.)then
         call out(0,'*** rho must be greater than zero')
         goto 9900
      endif
      a=sqrt(gam*p/r)
 9000 err319=0
      return
 9900 err319=1
      return
      end

      integer function err320(a,gam,rgas,t)
      implicit none
      real a,gam,rgas,t
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(rgas.le.0.)then
         call out(0,'*** R must be greater than zero')
         goto 9900
      endif
      if(t.le.0.)then
         call out(0,'*** T must be greater than zero')
         goto 9900
      endif
      a=sqrt(gam*rgas*t)
 9000 err320=0
      return
 9900 err320=1
      return
      end

      integer function err328(tt_t,gam,m)
      implicit none
      real tt_t,gam,m
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      tt_t=1.+(gam-1.)/2.*m**2
 9000 err328=0
      return
 9900 err328=1
      return
      end

      integer function eri328(m,gam,tt_t)
      implicit none
      real tt_t,gam,m
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(tt_t.lt.1.)then
         call out(0,'*** Tt/T must be greater than one')
         goto 9900
      endif
      m=sqrt((tt_t-1.)*2./(gam-1.))
 9000 eri328=0
      return
 9900 eri328=1
      return
      end

      integer function err330(pt_p,gam,m)
      implicit none
      real pt_p,gam,m
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      pt_p=(1.+(gam-1.)/2.*m**2)**(gam/(gam-1.))
 9000 err330=0
      return
 9900 err330=1
      return
      end

      integer function eri330(m,gam,pt_p)
      implicit none
      real pt_p,gam,m
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(pt_p.lt.1.)then
         call out(0,'*** Tt/T must be greater than one')
         goto 9900
      endif
      m=sqrt((pt_p**((gam-1.)/gam)-1.)*2./(gam-1.))
 9000 eri330=0
      return
 9900 eri330=1
      return
      end

      integer function err331(rt_r,gam,m)
      implicit none
      real rt_r,gam,m
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      rt_r=(1.+(gam-1.)/2.*m**2)**(1./(gam-1.))
 9000 err331=0
      return
 9900 err331=1
      return
      end

      integer function eri331(m,gam,rt_r)
      implicit none
      real rt_r,gam,m
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(rt_r.lt.1.)then
         call out(0,'*** Tt/T must be greater than one')
         goto 9900
      endif
      m=sqrt((rt_r**(gam-1.)-1.)*2./(gam-1.))
 9000 eri331=0
      return
 9900 eri331=1
      return
      end

      integer function err351(m2,gam,m1)
      implicit none
      real m2,gam,m1
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(m1.lt.1.)then
         call out(0,'*** M1 must be greater than one')
         goto 9900
      endif
      m2=1.
      if(m1.eq.1.)goto 9000
      m2=sqrt((1.+(gam-1.)/2.*m1**2)/(gam*m1**2-(gam-1)/2.))
 9000 err351=0
      return
 9900 err351=1
      return
      end

      integer function err353(r2_r1,gam,m1)
      implicit none
      real r2_r1,gam,m1
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(m1.lt.1.)then
         call out(0,'*** M1 must be greater than one')
         goto 9900
      endif
      r2_r1=1.
      if(m1.eq.1.)goto 9000
      r2_r1=(gam+1.)*m1**2/(2.+(gam-1.)*m1**2)
 9000 err353=0
      return
 9900 err353=1
      return
      end

      integer function err357(p2_p1,gam,m1)
      implicit none
      real p2_p1,gam,m1
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(m1.lt.1.)then
         call out(0,'*** M1 must be greater than one')
         goto 9900
      endif
      p2_p1=1.
      if(m1.eq.1.)goto 9000
      p2_p1=1.+(2.*gam)/(gam+1.)*(m1**2-1.)
 9000 err357=0
      return
 9900 err357=1
      return
      end

      integer function err359(t2_t1,gam,m1)
      implicit none
      real t2_t1,gam,m1
      real tmp
      integer err357,err353
      external err357,err353
      err359=err357(t2_t1,gam,m1)
      if(err359.ne.0)return
      err359=err353(tmp,gam,m1)
      t2_t1=t2_t1/tmp
      return
      end

      integer function err364(ptrat,gam,m1)
      implicit none
      real ptrat,gam,m1
      real prat,ptp1,ptp2,m2
      integer err357,err330,err351
      external err357,err330,err351
      err364=err357(prat,gam,m1)
      if(err364.ne.0)return
      err364=err330(ptp1,gam,m1)
      if(err364.ne.0)return
      err364=err351(m2,gam,m1)
      if(err364.ne.0)return
      err364=err330(ptp2,gam,m2)
      if(err364.ne.0)return
      ptrat=prat*(ptp2/ptp1)
      return
      end

      integer function err385(p_ps,gam,m)
      implicit none
      real p_ps,gam,m
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(m.le.0.)then
         call out(0,'*** M must be greater than zero')
         goto 9900
      endif
      p_ps=(gam+1.)/(gam+1.+gam*(m**2-1.))
 9000 err385=0
      return
 9900 err385=1
      return
      end

      integer function err386(t_ts,gam,m)
      implicit none
      real t_ts,gam,m
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(m.le.0.)then
         call out(0,'*** M must be greater than zero')
         goto 9900
      endif
      t_ts=(m*(gam+1.)/(gam+1.+gam*(m**2-1.)))**2
 9000 err386=0
      return
 9900 err386=1
      return
      end

      integer function err388(pt_pts,gam,m)
      implicit none
      real pt_pts,gam,m
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(m.le.0.)then
         call out(0,'*** M must be greater than zero')
         goto 9900
      endif
      pt_pts=(gam+1.)/(gam+1.+gam*(m**2-1.))*
     & ((gam+1.+(gam-1.)*(m**2-1.))/(gam+1.))**(gam/(gam-1.))
 9000 err388=0
      return
 9900 err388=1
      return
      end

      integer function err389(tt_tts,gam,m)
      implicit none
      real tt_tts,gam,m
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(m.le.0.)then
         call out(0,'*** M must be greater than zero')
         goto 9900
      endif
      tt_tts=((gam+1.+gam*(m**2-1.))**2-(m**2-1.)**2)
     & /(gam+1.+gam*(m**2-1.))**2
 9000 err389=0
      return
 9900 err389=1
      return
      end

      integer function err303(t_ts,gam,m)
      implicit none
      real t_ts,gam,m
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(m.le.0.)then
         call out(0,'*** M must be greater than zero')
         goto 9900
      endif
      t_ts=(gam+1.)/(gam+1.+(gam-1.)*(m**2-1.))
 9000 err303=0
      return
 9900 err303=1
      return
      end

      integer function err304(p_ps,gam,m)
      implicit none
      real p_ps,gam,m
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(m.le.0.)then
         call out(0,'*** M must be greater than zero')
         goto 9900
      endif
      p_ps=sqrt((gam+1.)/(gam+1.+(gam-1.)*(m**2-1.)))/m
 9000 err304=0
      return
 9900 err304=1
      return
      end

      integer function err306(pt_pts,gam,m)
      implicit none
      real pt_pts,gam,m
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(m.le.0.)then
         call out(0,'*** M must be greater than zero')
         goto 9900
      endif
      pt_pts=1./(m*
     & ((gam+1.)/(gam+1.+(gam-1.)*(m**2-1.)))**((gam+1.)/(2.*(gam-1.))))
 9000 err306=0
      return
 9900 err306=1
      return
      end

      integer function err307(f,gam,m)
      implicit none
      real f,gam,m
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(m.le.0.)then
         call out(0,'*** M must be greater than zero')
         goto 9900
      endif
      f=(1.-m**2)/(gam*m**2)+
     & (gam+1.)/(2.*gam)*alog((gam+1.)*m**2/(gam+1.+(gam-1.)*(m**2-1.)))
 9000 err307=0
      return
 9900 err307=1
      return
      end

      integer function err520(ar,gam,m)
      implicit none
      real ar,gam,m
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(m.le.0.)then
         call out(0,'*** M must be greater than zero')
         goto 9900
      endif
      ar=(1.+(gam-1.)/(gam+1.)*(m**2-1.))**((gam+1.)/(2.*(gam-1.)))/m
 9000 err520=0
      return
 9900 err520=1
      return
      end

      integer function err528(me,gam,p01_pe,at_ae)
      implicit none
      real me,gam,p01_pe,at_ae
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(p01_pe.lt.1.)then
         call out(0,'*** p01/pe must be greater than one')
         goto 9900
      endif
      if(at_ae.le.0.)then
         call out(0,'*** At/Ae must be greater than zero')
         goto 9900
      endif
      me=sqrt(1./(gam-1.)*(-1.+sqrt(1.+2.*(gam-1.)*
     & (2/(gam+1.))**((gam+1.)/(gam-1.))*(p01_pe*at_ae)**2)))
 9000 err528=0
      return
 9900 err528=1
      return
      end

      integer function err723(mr,gam,ms)
      implicit none
      real mr,gam,ms
      real tmp
      if(gam.le.1.)then
         call out(0,'*** gamma must be greater than one')
         goto 9900
      endif
      if(ms.lt.1.)then
         call out(0,'*** Ms must be greater than one')
         goto 9900
      endif
      mr=1.
      if(ms.eq.1.)goto 9000
      tmp=ms/(ms**2-1.)*sqrt(1.+2.*(gam-1.)/(gam+1)**2*
     & (ms**2-1.)*(gam+1./ms**2))
      tmp=.5/tmp
      mr=tmp+sqrt(1.+tmp**2)
 9000 err723=0
      return
 9900 err723=1
      return
      end

      integer function err794(p4_p1,gam1,gam4,a1_a4,p2_p1)
      implicit none
      real p4_p1,gam1,gam4,a1_a4,p2_p1
      real tmp,pow
      tmp=2.*gam1*(2.*gam1+(gam1+1.)*(p2_p1-1.))
      if(gam1.le.1.)then
         call out(0,'*** gamma1 must be greater than one')
         goto 9900
      endif
      if(gam4.le.1.)then
         call out(0,'*** gamma4 must be greater than one')
         goto 9900
      endif
      if(tmp.le.0.)then
         call out(0,'*** invalid parameters')
         goto 9900
      endif
      pow=-2.*gam4/(gam4-1.)
      p4_p1=p2_p1*
     & (1.-(gam4-1.)*a1_a4*(p2_p1-1.)/sqrt(tmp))**pow
 9000 err794=0
      return
 9900 err794=1
      return
      end
