      subroutine out(nocr,str)

c     writes string str to standard output and the log file

      implicit none

c input

c     nonzero to suppress the carriage return
      integer nocr

c     string to write
      character*(*) str

c local

c     nonzero to write a bell
      integer bell

   20 format(a,$)
   21 format(a1,a,$)
   30 format(a)
   31 format(a1,a)

      bell=0
      if(str(1:1).eq.'*')bell=1

      if(bell.eq.0 .and. nocr.eq.0)print30,str
      if(bell.ne.0 .and. nocr.eq.0)print31,char(7),str
      if(bell.eq.0 .and. nocr.ne.0)print20,str
      if(bell.ne.0 .and. nocr.ne.0)print21,char(7),str
      write(3,30,err=9999)str
      return

 9999 print*,'*** Unable to write to log file gaseqs.log:'
      print*,'    Check disk space and permissions'
      stop
      end

      subroutine out2(nocr,str1,str2)

c     Version of out that has two strings.  Needed for the g77 compiler.

      implicit none

c input

c     nonzero to suppress the carriage return
      integer nocr

c     string to write
      character*(*) str1,str2

c local

c     nonzero to write a bell
      integer bell

   20 format(2a,$)
   21 format(a1,2a,$)
   30 format(2a)
   31 format(a1,2a)

      bell=0
      if(str1(1:1).eq.'*')bell=1

      if(bell.eq.0 .and. nocr.eq.0)print30,str1,str2
      if(bell.ne.0 .and. nocr.eq.0)print31,char(7),str1,str2
      if(bell.eq.0 .and. nocr.ne.0)print20,str1,str2
      if(bell.ne.0 .and. nocr.ne.0)print21,char(7),str1,str2
      write(3,30,err=9999)str1,str2
      return

 9999 print*,'*** Unable to write to log file gaseqs.log:'
      print*,'    Check disk space and permissions'
      stop
      end


      subroutine out4(nocr,str1,str2,str3,str4)

c     Version of out that has 4 strings.  Needed for the g77 compiler.

      implicit none

c input

c     nonzero to suppress the carriage return
      integer nocr

c     string to write
      character*(*) str1,str2,str3,str4

c local

c     nonzero to write a bell
      integer bell

   20 format(4a,$)
   21 format(a1,4a,$)
   30 format(4a)
   31 format(a1,4a)

      bell=0
      if(str1(1:1).eq.'*')bell=1

      if(bell.eq.0 .and. nocr.eq.0)print30,str1,str2,str3,str4
      if(bell.ne.0 .and. nocr.eq.0)print31,char(7),str1,str2,str3,str4
      if(bell.eq.0 .and. nocr.ne.0)print20,str1,str2,str3,str4
      if(bell.ne.0 .and. nocr.ne.0)print21,char(7),str1,str2,str3,str4
      write(3,30,err=9999)str1,str2,str3,str4
      return

 9999 print*,'*** Unable to write to log file gaseqs.log:'
      print*,'    Check disk space and permissions'
      stop
      end



      subroutine in(line)

c     reads 80 character line from standard input

      implicit none

c output

c     line read
      character*80 line

c local

c     character index
      integer i,imx

c     whether we initialized
      integer init
      save init
      data init/0/

c     whether a recovery file exists
      logical exists

c     line from recovery file
      character*88 line2

 10   format(a80)
 11   format(a88)
 20   format(a,$)
 30   format('input-->',a)
 40   format(a)

c     look for a recovery file
      if(init.eq.0)then
         init=2
         inquire(file='gaseqs.rcv',exist=exists)
         if(exists)then
            open(9,file='gaseqs.rcv',status='old',err=9991)
            init=1
         endif
      endif

c     read from recovery file if init=1
      if(init.gt.1)goto 100
 50   read(9,11,err=9992,end=90)line2
      if(line2(1:8).ne.'input-->')goto 50
      line=line2(9:88)
      print40,line(1:30)
      goto 110
 90   init=2

 100  read(*,10,err=9990)line
 110  do 200 i=80,1,-1
         imx=i
         if(line(i:i).gt.' ')goto 210
 200  continue
 210  write(3,30,err=9999)line(1:imx)

      return
 9990 print30,char(7)//'*** Error during read'
      print20,'    please try entering again: '
      goto 100
 9991 print30,char(7)//'*** Unable to open recovery file gaseqs.rcv:'
      print30,'    Check file permissions'
      stop
 9992 print30,char(7)//
     & '*** Unable to read from recovery file gaseqs.rcv:'
      print30,'    Check file permissions'
      stop
 9999 print30,char(7)//'*** Unable to write to log file gaseqs.log:'
      print30,'    Check disk space and permissions'
      stop
      end



      subroutine strcln(errini,*,str,strlen,cheq,charr,chmax)

c     clean a string:
c     - return a nonzero error code on control characters
c     - replace tabs by single spaces
c     - get rid of leading and trailing spaces
c     - get rid of spaces around = signs and > signs

      implicit none

c input

c     error prefix if something goes wrong
      character*(*) errini

c     string to clean
      character*(*) str
c     dimensioned string length
      integer strlen

c output

c     position of equals-sign or 0 if none
      integer cheq
c     position of arrow or chmax+1 if none
      integer charr
c     actual length of string
      integer chmax

c local

c     character index
      integer i,i2,ibuf

c     initialize
      cheq=0
      charr=0
      i2=0
      ibuf=0

      do 100 i=1,strlen
c        turn tabs into single spaces
         if(str(i:i).eq.char(9))str(i:i)=' '
c        check for invalid characters
         if(str(i:i).lt.' ' .or. str(i:i).gt.'~')then
            call out2(0,errini,'invalid character in string')
            return 1
         endif
         if(str(i:i).eq.' ')then
c           get rid of spaces at the start
            if(i2.eq.0)goto 100
c           get rid of spaces after = and >
            if(str(i2:i2).eq.'=' .or. str(i2:i2).eq.'>')goto 100
c           buffer them
            ibuf=ibuf+1
         else
c           get rid of spaces before = and >
            if(str(i:i).eq.'=' .or. str(i:i).eq.'>')ibuf=0
c           dump the buffer and the character to the cleaned-up string
            if(ibuf.gt.0)str(i2+1:i2+ibuf)=' '
            i2=i2+ibuf
            ibuf=0
            i2=i2+1
            str(i2:i2)=str(i:i)
c           store the position of =
            if(str(i:i).eq.'=')then
               if(cheq.gt.0)then
                  call out2(0,errini,'more than one "=" in string')
                  return 1
               endif
               cheq=i2
            endif
c           store the position of >
            if(str(i:i).eq.'>')then
               if(charr.gt.0)then
                  call out2(0,errini,'more than one ">" in string')
                  return 1
               endif
               charr=i2
            endif
         endif
 100  continue
      chmax=i2
      if(charr.eq.0)charr=chmax+1

      return
      end


      integer function memnum(memdim,memmax,memnam,str,lt)

c     index of a given memory name

c     returns 0 if the name is invalid
c     returns memmax+1 if the memory location does not yet exist

c     needs a blank-eliminated string

      implicit none

c input

c     declared number of memory locations
      integer memdim
c     actual number of memory locations used
      integer memmax
c     memory name
      integer memlen
      parameter (memlen=14)
      character*(memlen) memnam(memdim)

c     memory name to find the index of
      character*(*) str
      integer lt

c local

c     character index
      integer ch

c     memory index
      integer mem

c     check the name for legality
      memnum=0
      if(lt.lt.1 .or. lt.gt.memlen)return
      do 100 ch=1,lt
         if(str(ch:ch).ge.'A' .and. str(ch:ch).le.'Z')goto 100
         if(str(ch:ch).ge.'a' .and. str(ch:ch).le.'z')goto 100
         if(ch.eq.1)return
         if(str(ch:ch).ge.'0' .and. str(ch:ch).le.'9')goto 100
         if(str(ch:ch).eq.'_')goto 100
         if(str(ch:ch).eq.'@')goto 100
         if(str(ch:ch).eq.'/')goto 100
         if(str(ch:ch).eq.'*')goto 100
         if(str(ch:ch).eq.'.')goto 100
         if(str(ch:ch).eq.'"')goto 100
         if(str(ch:ch).eq.'''')goto 100
         return
 100  continue

c     find any existing storage location with that name
      memnum=1
      do 200 mem=1,memmax
         if(memnam(mem).eq.str(1:lt))return
         memnum=memnum+1
 200  continue

      return
      end


      subroutine mstore(memdim,memmax,memnam,memval,str,lt,val)

c     store a number in a memory location

c     terminates program if name has blanks (but will truncate trailing
c     blanks,) or is invalid or if storage is exceeded,

      implicit none

c input

c     declared number of memory locations
      integer memdim
c     actual number of memory locations used
      integer memmax
c     memory name
      integer memlen
      parameter (memlen=14)
      character*(memlen) memnam(memdim)
c     memory values
      real memval(memdim)

c     memory name to store in
      character*(*) str
      integer lt
c     value to store
      real val

c local

c     reduced length of the string
      integer lt2

c     character index
      integer ch

c     memory index to store in
      integer mem

c     memory location index finder
      integer memnum
      external memnum

      lt2=lt
      do 100 ch=lt,1,-1
         if(str(ch:ch).gt.' ')goto 110
         lt2=ch-1
 100  continue
 110  continue

      mem=memnum(memdim,memmax,memnam,str,lt2)
      if(mem.le.0)then
         if(lt2.le.0)call out(0,
     &    '*** PROGRAM ERROR: empty memory name passed to mstore')
         if(lt2.gt.0)call out4(0,
     &    '*** PROGRAM ERROR: invalid memory name passed to mstore: ',
     &    '"',str(1:lt),'"')
         stop
      endif
      if(mem.gt.memdim)then
         call out(0,
     &    '*** PROGRAM ERROR: out of memory storage')
         stop
      endif
      memval(mem)=val
      if(mem.le.memmax)return
      memmax=mem
      memnam(mem)=str(1:lt2)

      return
      end

      subroutine mget(*,memdim,memmax,memnam,memval,str,lt,val)

c     get a number from a memory location

c     truncates trailing blanks from the name

c     takes return 1 if the memory location does not exist

      implicit none

c input

c     declared number of memory locations
      integer memdim
c     actual number of memory locations used
      integer memmax
c     memory name
      integer memlen
      parameter (memlen=14)
      character*(memlen) memnam(memdim)
c     memory values
      real memval(memdim)

c     memory name to store in
      character*(*) str
      integer lt

c output

c     value stored under name str(1:lt)
      real val

c local

c     reduced length of the string
      integer lt2

c     character index
      integer ch

c     memory index
      integer mem

c     memory location index finder
      integer memnum
      external memnum

      lt2=lt
      do 100 ch=lt,1,-1
         if(str(ch:ch).gt.' ')goto 110
         lt2=ch-1
 100  continue
 110  continue

      mem=memnum(memdim,memmax,memnam,str,lt2)
      if(mem.le.0 .or. mem.gt.memmax)return 1
      val=memval(mem)

      return
      end


      subroutine quit(*,str,lt)

c     if the string is a variant of quit, jump to the statement number

      implicit none

c     string to read
      character*(*) str
c     string length
      integer lt

      if(lt.le.0)return
      if(str(1:lt).eq.'exit')return 1
      if(str(1:lt).eq.'EXIT')return 1
      if(str(1:lt).eq.'quit')return 1
      if(str(1:lt).eq.'QUIT')return 1
      if(str(1:lt).eq.'q')return 1
      if(str(1:lt).eq.'Q')return 1

      return
      end


      subroutine readvl(errini,*,str,lt,memdim,memmax,memnam,memval,
     & value,mem)

c     reads a value from string str or performs an error return

      implicit none

c input

c     error prefix if something goes wrong
      character*(*) errini

c     string to read
      character*(*) str
c     string length
      integer lt

c     declared number of memory locations
      integer memdim
c     actual number of memory locations used
      integer memmax
c     memory name
      integer memlen
      parameter (memlen=14)
      character*(memlen) memnam(memdim)
c     memory values
      real memval(memdim)

c output

c     value read
      real value

c     memory location the value is read from (0=none)
      integer mem

c local

c     numerical memory location from string
      integer memnum
      external memnum

c     character index and actual string bounds
      integer i,i1,i2

c     temporary
      real tmp

c     find actual string bounds

      do 100 i=1,lt
         i1=i
         if(str(i:i).gt.' ')goto 110
 100  continue
      call out2(0,errini,'missing value')
      return 1
 110  continue

      do 120 i=lt,i1,-1
         i2=i
         if(str(i:i).gt.' ')goto 130
 120  continue
 130  continue

c     try reading the string as a memory location
      mem=memnum(memdim,memmax,memnam,str(i1:i2),i2-i1+1)
      if(mem.gt.0 .and. mem.le.memmax)then
         value=memval(mem)
         return
      else
         do 205 i=i1,i2
            if(str(i:i).ge.'0' .and. str(i:i).le.'9')goto 205
            if(str(i:i).eq.'e' .or. str(i:i).eq.'E')goto 205
            if(str(i:i).eq.'d' .or. str(i:i).eq.'D')goto 205
            if(str(i:i).eq.'.' .or. str(i:i).eq.' ')goto 205
            if(str(i:i).eq.'-' .or. str(i:i).eq.'+')goto 205
            goto 210
 205     continue
         read(str(i1:i2),*,err=210)tmp
         value=tmp
         mem=0
         return
 210     call out4(0,errini,'invalid number or undefined name "',
     &    str(i1:i2),'"')
         return 1
      endif

      end

 
      integer function eval(str,lt,memdim,memmax,memnam,memval,value)

c     evaluates the algebraic expression str and stores it in value

c     it ignores all spaces in the input

c     recognizes ^ for exponentiation and the functions:
c     sin, cos, exp, log, atan (arctan), and sqrt

      implicit none

c input

c     string to compress and then evaluate
      character*(*) str
c     string length
      integer lt

c     declared number of memory locations
      integer memdim
c     actual number of memory locations used
      integer memmax
c     memory name
      integer memlen
      parameter (memlen=14)
      character*(memlen) memnam(memdim)
c     memory values
      real memval(memdim)

c output

c     computed value
      real value

c local

c     character index
      integer i,ibeg

c     declared dimension of the parenthical expression to evaluate
      integer pardim
      parameter (pardim=840)
c     actual dimension of the parenthical expression to evaluate
      integer parlt
c     parenthical expression to evaluate
      character*(pardim) parexp
c     location of the current set of parentheses
      integer parbeg,parend

c     simple nonparenthical expression to evaluate
      character*(pardim) simexp
      integer simlt
c     declared number of fields in the simple expression
      integer flddim
      parameter (flddim=81)
c     actual number of fields in the simple expression
      integer fldmax
c     field index
      integer fld,fld2
c     type of field
      character*1 fldtyp(flddim)
c     priority of the field operator
      integer fldpri(flddim)
c     value of the field value
      real fldval(flddim)

c     priority
      integer pri

c     memory location
      integer mem

c     convert string to a parenthical expression, eliminating all spaces
      parlt=1
      parexp(parlt:parlt)='('
      do 100 i=1,lt
         if(str(i:i).le.' ')goto 100
         parlt=parlt+1
         if(parlt.gt.pardim-1)then
            call out(0,'*** expression is too long')
            goto 9999
         endif
         parexp(parlt:parlt)=str(i:i)
 100  continue
      parlt=parlt+1
      parexp(parlt:parlt)=')'

c     scan through the string to find a simple expression
 1000 parend=parlt
      parlt=0
      do 1010 i=1,parend
         if(parexp(i:i).le.' ')goto 1010
         parlt=parlt+1
         parexp(parlt:parlt)=parexp(i:i)
 1010 continue
      parbeg=1
      do 1100 i=2,parlt
         if(parexp(i:i).eq.'(')parbeg=i
         parend=i
         if(parexp(i:i).eq.')')goto 2000
 1100 continue
      call out(0,'*** unmatched parentheses')
      goto 9999

c     take apart the found simple string
 2000 if(parbeg.le.1 .and. parend.ne.parlt)then
         call out(0,'*** unmatched parentheses')
         goto 9999
      endif
      simlt=parend-parbeg+1
      if(simlt.le.0)then
         call out(0,'*** empty subexpression')
         goto 9999
      endif
      simexp(1:simlt)=parexp(parbeg:parend)
      fldmax=0
      ibeg=2
      do 2100 i=2,simlt
         if(i.ne.simlt .and. simexp(i:i).ne.'^' .and.
     &    simexp(i:i).ne.'&' .and. simexp(i:i).ne.':' .and.
     &    simexp(i:i).ne.'+' .and. simexp(i:i).ne.'-')goto 2100
         if(fldmax.ge.flddim-1)then
            call out(0,'*** out of storage')
            goto 9999
         endif
         if(ibeg.lt.i)then
            fldmax=fldmax+1
            fldtyp(fldmax)='_'
            fldpri(fldmax)=0
            call readvl('*** ',*9999,simexp(ibeg:i-1),i-ibeg,
     &       memdim,memmax,memnam,memval,fldval(fldmax),mem)
         endif
         ibeg=i+1
         if(i.eq.simlt)goto 2100
         fldmax=fldmax+1
         fldtyp(fldmax)=simexp(i:i)
         fldval(fldmax)=0.
         if(fldtyp(fldmax).eq.'^')fldpri(fldmax)=3
         if(fldtyp(fldmax).eq.'&' .or. fldtyp(fldmax).eq.':')
     &    fldpri(fldmax)=2
         if(fldtyp(fldmax).eq.'+' .or. fldtyp(fldmax).eq.'-')then
            fldpri(fldmax)=4
            if(fldtyp(max(1,fldmax-1)).eq.'_')fldpri(fldmax)=1
         endif
 2100 continue

c     process the pieces
 3000 if(fldmax.le.0)then
         call out(0,'*** missing number')
         goto 9999
      endif
      do 3500 pri=4,1,-1
         fld=0
 3100    fld=fld+1
         if(fld.gt.fldmax)goto 3500
         if(fldpri(fld).ne.pri)goto 3100
         if(fldtyp(min(fldmax,fld+1)).ne.'_')then
            call out(0,'*** missing number')
            goto 9999
         endif
         if(pri.eq.4)then
            if(fldtyp(fld).eq.'-')fldval(fld+1)=-fldval(fld+1)
            do 3200 fld2=fld+1,fldmax
               fldtyp(fld2-1)=fldtyp(fld2)
               fldpri(fld2-1)=fldpri(fld2)
               fldval(fld2-1)=fldval(fld2)
 3200       continue
            fldmax=fldmax-1
            goto 3100
         endif
         if(fldtyp(max(1,fld-1)).ne.'_')then
            call out(0,'*** missing number')
            goto 9999
         endif
         if(fldtyp(fld).eq.'^')then
            if(fldval(fld-1).lt.0.)then
               call out(0,'*** power of a negative number')
               goto 9999
            endif
            if(fldval(fld-1).gt.0.)
     &       fldval(fld-1)=fldval(fld-1)**fldval(fld+1)
         endif
         if(fldtyp(fld).eq.'&')fldval(fld-1)=fldval(fld-1)*fldval(fld+1)
         if(fldtyp(fld).eq.':')then
            if(fldval(fld+1).eq.0.)then
               call out(0,'*** division by zero')
               goto 9999
            endif
            fldval(fld-1)=fldval(fld-1)/fldval(fld+1)
         endif
         if(fldtyp(fld).eq.'+')fldval(fld-1)=fldval(fld-1)+fldval(fld+1)
         if(fldtyp(fld).eq.'-')fldval(fld-1)=fldval(fld-1)-fldval(fld+1)
         do 3300 fld2=fld+2,fldmax
            fldtyp(fld2-2)=fldtyp(fld2)
            fldpri(fld2-2)=fldpri(fld2)
            fldval(fld2-2)=fldval(fld2)
 3300    continue
         fld=fld-1
         fldmax=fldmax-2
         goto 3100
 3500 continue
c     no more operators
      if(fldmax.ne.1 .or. fldtyp(1).ne.'_')then
         call out(0,'*** program error')
         print*,fldmax
         print*,(fldtyp(fld),fld=1,fldmax)
         print*,(fldpri(fld),fld=1,fldmax)
         print*,(fldval(fld),fld=1,fldmax)
         stop
      endif

c     see whether there is a function name before the parenthesis
      ibeg=parbeg
      do 4100 i=parbeg-1,1,-1
         if(parexp(i:i).ge.'A' .and. parexp(i:i).le.'Z')
     &    parexp(i:i)=char(ichar(parexp(i:i))+32)
         ibeg=i+1
         if(parexp(i:i).lt.'a' .or. parexp(i:i).gt.'z')goto 4110
 4100 continue
 4110 if(ibeg.ge.parbeg)goto 5000
      if(parexp(ibeg:parbeg-1).eq.'sqrt')then
         if(fldval(1).lt.0.)then
            call out(0,'*** square root of negative number')
            goto 9999
         endif
         fldval(1)=sqrt(fldval(1))
      else if(parexp(ibeg:parbeg-1).eq.'exp')then
         fldval(1)=exp(fldval(1))
      else if(parexp(ibeg:parbeg-1).eq.'log')then
         if(fldval(1).le.0.)then
            call out(0,'*** logarithm of nonpositive number')
            goto 9999
         endif
         fldval(1)=log(fldval(1))
      else if(parexp(ibeg:parbeg-1).eq.'sin')then
         fldval(1)=sin(fldval(1))
      else if(parexp(ibeg:parbeg-1).eq.'cos')then
         fldval(1)=cos(fldval(1))
      else if(parexp(ibeg:parbeg-1).eq.'tan')then
         fldval(1)=tan(fldval(1))
      else if(parexp(ibeg:parbeg-1).eq.'atan')then
         fldval(1)=atan(fldval(1))
      else if(parexp(ibeg:parbeg-1).eq.'a')then
         if(fldval(1).lT.0.)then
            call out(0,'*** temperature is negative')
            goto 9999
         endif
         fldval(1)=sqrt(memval(1)*memval(2)*fldval(1))
      else
         call out(0,'*** unrecognized function "'//
     &    parexp(ibeg:parbeg-1)//'"')
         call out(0,
     &    '    recognized: sqrt, exp, log, sin, cos, tan, atan, a')
         goto 9999
      endif
      parexp(ibeg:parbeg-1)=' '

c     see whether we are done
 5000 if(parbeg.eq.1)then
         value=fldval(1)
         goto 9990
      endif

c     throw out the subexpression in favor of its value
      simexp(1:parlt)=parexp(1:parlt)
      i=parbeg-1+20+parlt-parend
      if(i.gt.pardim)then
         call out(0,'*** process string space too much')
         goto 9999
      endif
      parexp(parbeg+20:i)=simexp(parend+1:parlt)
      parlt=i
      parexp(parbeg:parbeg+19)=' '
      write(parexp(parbeg:parbeg+19),6110)fldval(1)
 6110 format(g20.7)
      goto 1000

 9990 eval=0
      return
 9999 eval=1
      return
      end
